import { browser, ExpectedConditions as ec /* , promise */ } from 'protractor';
import { NavBarPage, SignInPage } from '../../page-objects/jhi-page-objects';

import {
  UserWatchListComponentsPage,
  /* UserWatchListDeleteDialog, */
  UserWatchListUpdatePage,
} from './user-watch-list.page-object';

const expect = chai.expect;

describe('UserWatchList e2e test', () => {
  let navBarPage: NavBarPage;
  let signInPage: SignInPage;
  let userWatchListComponentsPage: UserWatchListComponentsPage;
  let userWatchListUpdatePage: UserWatchListUpdatePage;
  /* let userWatchListDeleteDialog: UserWatchListDeleteDialog; */

  before(async () => {
    await browser.get('/');
    navBarPage = new NavBarPage();
    signInPage = await navBarPage.getSignInPage();
    await signInPage.autoSignInUsing('admin', 'search@admin');
    await browser.wait(ec.visibilityOf(navBarPage.entityMenu), 5000);
    // await navBarPage.clickOnEntityMenu();
  });

  it('should load UserWatchLists', async () => {
    await navBarPage.goToEntity('user-watch-list');
    userWatchListComponentsPage = new UserWatchListComponentsPage();
    await browser.wait(ec.visibilityOf(userWatchListComponentsPage.title), 5000);
    expect(await userWatchListComponentsPage.getTitle()).to.eq('gitsearchApp.userWatchList.home.title');
    await browser.wait(
      ec.or(ec.visibilityOf(userWatchListComponentsPage.entities), ec.visibilityOf(userWatchListComponentsPage.noResult)),
      1000
    );
  });

  it('should load create UserWatchList page', async () => {
    await userWatchListComponentsPage.clickOnCreateButton();
    userWatchListUpdatePage = new UserWatchListUpdatePage();
    expect(await userWatchListUpdatePage.getPageTitle()).to.eq('gitsearchApp.userWatchList.home.createOrEditLabel');
    await userWatchListUpdatePage.cancel();
  });

  /* it('should create and save UserWatchLists', async () => {
        const nbButtonsBeforeCreate = await userWatchListComponentsPage.countDeleteButtons();

        await userWatchListComponentsPage.clickOnCreateButton();

        await promise.all([
            userWatchListUpdatePage.setNameInput('name'),
            userWatchListUpdatePage.checkFrequencySelectLastOption(),
            userWatchListUpdatePage.userIdSelectLastOption(),
        ]);

        expect(await userWatchListUpdatePage.getNameInput()).to.eq('name', 'Expected Name value to be equals to name');

        await userWatchListUpdatePage.save();
        expect(await userWatchListUpdatePage.getSaveButton().isPresent(), 'Expected save button disappear').to.be.false;

        expect(await userWatchListComponentsPage.countDeleteButtons()).to.eq(nbButtonsBeforeCreate + 1, 'Expected one more entry in the table');
    }); */

  /* it('should delete last UserWatchList', async () => {
        const nbButtonsBeforeDelete = await userWatchListComponentsPage.countDeleteButtons();
        await userWatchListComponentsPage.clickOnLastDeleteButton();

        userWatchListDeleteDialog = new UserWatchListDeleteDialog();
        expect(await userWatchListDeleteDialog.getDialogTitle())
            .to.eq('gitsearchApp.userWatchList.delete.question');
        await userWatchListDeleteDialog.clickOnConfirmButton();

        expect(await userWatchListComponentsPage.countDeleteButtons()).to.eq(nbButtonsBeforeDelete - 1);
    }); */

  after(async () => {
    await navBarPage.autoSignOut();
  });
});
